(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('dayjs'), require('@angular/common'), require('@angular/forms'), require('@douglas-serena/ng-masks'), require('@douglas-serena/ng-utils'), require('@angular/cdk/overlay')) :
    typeof define === 'function' && define.amd ? define('@douglas-serena/ng-inputs-bootstrap', ['exports', '@angular/core', 'dayjs', '@angular/common', '@angular/forms', '@douglas-serena/ng-masks', '@douglas-serena/ng-utils', '@angular/cdk/overlay'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['douglas-serena'] = global['douglas-serena'] || {}, global['douglas-serena']['ng-inputs-bootstrap'] = {}), global.ng.core, global.dayjs, global.ng.common, global.ng.forms, global.ngMasks, global.ngUtils, global.ng.cdk.overlay));
}(this, (function (exports, i0, dayjs, common, forms, ngMasks, ngUtils, overlay) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var dayjs__namespace = /*#__PURE__*/_interopNamespace(dayjs);

    var NgConfigService = /** @class */ (function () {
        function NgConfigService() {
            this._config = {
                global: {
                    select: {},
                    textArea: {},
                    autocomplete: {
                        icon: {
                            loading: {
                                icon: 'fas fa-spinner ng-bt-loading',
                            },
                            left: {
                                icon: 'fas fa-search',
                            },
                        },
                    },
                    input: {
                        types: {
                            password: {
                                icon: {
                                    right: {
                                        icon: 'fas fa-eye',
                                        click: function (_, input, icon) {
                                            if (input.type === 'password') {
                                                icon.icon = 'fas fa-eye-slash';
                                                input.type = 'text';
                                            }
                                            else {
                                                icon.icon = 'fas fa-eye';
                                                input.type = 'password';
                                            }
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
            };
        }
        Object.defineProperty(NgConfigService.prototype, "global", {
            get: function () {
                return this.config.global;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "input", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.input;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "select", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.select;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "textarea", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.textArea;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "autocomplete", {
            get: function () {
                var _a;
                return (_a = this.global) === null || _a === void 0 ? void 0 : _a.autocomplete;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "config", {
            get: function () {
                return this._config;
            },
            set: function (value) {
                this._config.global = Object.assign(Object.assign({}, this._config.global), value.global);
            },
            enumerable: false,
            configurable: true
        });
        NgConfigService.prototype.types = function (field) {
            var _a, _b;
            return (_b = (_a = this.global) === null || _a === void 0 ? void 0 : _a[field]) === null || _b === void 0 ? void 0 : _b.types;
        };
        Object.defineProperty(NgConfigService.prototype, "typesSelect", {
            get: function () {
                return this.types('select');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "typesInput", {
            get: function () {
                return this.types('input');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "typesTextArea", {
            get: function () {
                return this.types('textArea');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgConfigService.prototype, "typesAutocomplete", {
            get: function () {
                return this.types('autocomplete');
            },
            enumerable: false,
            configurable: true
        });
        return NgConfigService;
    }());
    NgConfigService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgConfigService_Factory() { return new NgConfigService(); }, token: NgConfigService, providedIn: "root" });
    NgConfigService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];

    var NgConfigModule = /** @class */ (function () {
        function NgConfigModule() {
        }
        NgConfigModule.forRoot = function () {
            return {
                ngModule: NgConfigModule,
                providers: [NgConfigService],
            };
        };
        return NgConfigModule;
    }());
    NgConfigModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [],
                    exports: [],
                    providers: [NgConfigService],
                },] }
    ];

    var NgInputsBootstrap = /** @class */ (function () {
        function NgInputsBootstrap() {
        }
        NgInputsBootstrap.forRoot = function (options) {
            return {
                ngModule: NgInputsBootstrap,
                providers: [
                    NgConfigService,
                    {
                        provide: FOR_ROOT_OPTIONS_TOKEN,
                        useValue: options,
                    },
                    {
                        provide: NgConfigService,
                        useFactory: provideMyServiceOptions,
                        deps: [FOR_ROOT_OPTIONS_TOKEN],
                    },
                ],
            };
        };
        return NgInputsBootstrap;
    }());
    NgInputsBootstrap.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [NgConfigModule],
                },] }
    ];
    var FOR_ROOT_OPTIONS_TOKEN = new i0.InjectionToken('forRoot() NgConfigService() configuration.');
    function provideMyServiceOptions(configs) {
        var service = new NgConfigService();
        if (configs) {
            service.config = configs;
        }
        return service;
    }

    var NgFormatDateByTypeService = /** @class */ (function () {
        function NgFormatDateByTypeService() {
            this.typeDate = ['date', 'datetime-local', 'month', 'time'];
        }
        NgFormatDateByTypeService.prototype.format = function (value, typeDate) {
            var formulation = {
                'datetime-local': dayjs__namespace(value).format('YYYY-MM-DDTHH:mm:ss'),
                date: dayjs__namespace(value).format('YYYY-MM-DD'),
                month: dayjs__namespace(value).format('YYYY-MM'),
                time: dayjs__namespace(value).format('HH:mm'),
            };
            return formulation[typeDate];
        };
        return NgFormatDateByTypeService;
    }());
    NgFormatDateByTypeService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgFormatDateByTypeService_Factory() { return new NgFormatDateByTypeService(); }, token: NgFormatDateByTypeService, providedIn: "root" });
    NgFormatDateByTypeService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgFormatDateByTypeService.ctorParameters = function () { return []; };

    var NgUtilsServiceModule = /** @class */ (function () {
        function NgUtilsServiceModule() {
        }
        NgUtilsServiceModule.forRoot = function () {
            return {
                ngModule: NgUtilsServiceModule,
                providers: [NgFormatDateByTypeService],
            };
        };
        return NgUtilsServiceModule;
    }());
    NgUtilsServiceModule.decorators = [
        { type: i0.NgModule, args: [{
                    providers: [NgFormatDateByTypeService],
                },] }
    ];

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || from);
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var ControlBase = /** @class */ (function () {
        function ControlBase(_controlContainer, _renderer2, _ngConfig) {
            var _this = this;
            this._controlContainer = _controlContainer;
            this._renderer2 = _renderer2;
            this._ngConfig = _ngConfig;
            this.label = '';
            this.type = 'text';
            this.readonly = false;
            this.disabled = false;
            this.required = null;
            this.labelFixed = false;
            this.color = 'primary';
            this.size = 'md';
            this.theme = 'outline';
            this.blur = new i0.EventEmitter();
            this.focus = new i0.EventEmitter();
            this.handleChange = function (_) { };
            this.handleTouched = function () { };
            this.registerOnTouched = function (fn) { return (_this.handleTouched = fn); };
            this.setDisabledState = function (isDisabled) { return (_this.disabled = isDisabled); };
            this.registerOnChange = function (fn) { return (_this.handleChange = fn); };
            this.writeValue = function (value) { };
        }
        Object.defineProperty(ControlBase.prototype, "placeholder", {
            set: function (text) {
                var _a;
                this._placeholder = text;
                if (!!text && ((_a = this.rootRef) === null || _a === void 0 ? void 0 : _a.nativeElement)) {
                    this._renderer2.setAttribute(this.rootRef.nativeElement, 'placeholder', text);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ControlBase.prototype, "errors", {
            set: function (errors) {
                if (errors) {
                    this._errors = errors;
                    this._errorsKeys = Object.keys(errors);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ControlBase.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl ||
                    ((_b = (_a = this._controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        ControlBase.prototype.superOnInit = function (typeField) {
            var _a, _b, _c;
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
            if (this.required === null) {
                var value = this.control.value;
                this.control.reset();
                this.required = !!this.control.getError('required');
                this.control.setValue(value);
            }
            var iconType = (_b = (_a = this._ngConfig.types(typeField)) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()]) === null || _b === void 0 ? void 0 : _b.icon;
            var iconGlobal = (_c = this._ngConfig[typeField]) === null || _c === void 0 ? void 0 : _c.icon;
            this.icon = Object.assign({}, iconGlobal, iconType, this.icon);
        };
        ControlBase.prototype.superAfterViewInit = function () {
            if (!!this._placeholder) {
                this.placeholder = this._placeholder;
            }
        };
        ControlBase.prototype.handleClickIcon = function (prop, input, position) {
            var _a;
            prop.event.stopPropagation();
            if ((_a = prop.icon) === null || _a === void 0 ? void 0 : _a.click) {
                prop.icon.click(prop.event, input, prop.icon, position);
            }
            else {
                input.focus();
            }
        };
        ControlBase.prototype.handleBlur = function (event) {
            this.handleTouched();
            this.blur.emit(event);
        };
        ControlBase.prototype.handleFocus = function (event) {
            this.focus.emit(event);
        };
        return ControlBase;
    }());
    ControlBase.decorators = [
        { type: i0.Component, args: [{
                    template: ''
                },] }
    ];
    ControlBase.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: NgConfigService }
    ]; };
    ControlBase.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        rootRef: [{ type: i0.ViewChild, args: ['rootRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        prefix: [{ type: i0.Input }],
        suffix: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        labelFixed: [{ type: i0.Input }],
        placeholder: [{ type: i0.Input }],
        help: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        icon: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        theme: [{ type: i0.Input }],
        errors: [{ type: i0.Input }],
        blur: [{ type: i0.Output }],
        focus: [{ type: i0.Output }]
    };

    function compareObject(objectOne, ObjectTwo) {
        return JSON.stringify(objectOne) === JSON.stringify(ObjectTwo);
    }
    function compareOptions(options, keys, _with) {
        return options.find(function (item) {
            return compareObject(ngUtils.getNode(item._root, keys), _with);
        });
    }

    var PROVIDER_VALUE_ACCESSOR$5 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgAutocompleteComponent; }),
        multi: true,
    };
    var NgAutocompleteComponent = /** @class */ (function (_super) {
        __extends(NgAutocompleteComponent, _super);
        function NgAutocompleteComponent(renderer2, ngMaskService, ngConfig, controlContainer, changeDetectorRef) {
            var _this = _super.call(this, controlContainer, renderer2, ngConfig) || this;
            _this.renderer2 = renderer2;
            _this.ngMaskService = ngMaskService;
            _this.ngConfig = ngConfig;
            _this.changeDetectorRef = changeDetectorRef;
            _this.loading = false;
            _this.keyLabel = '';
            _this.keyValue = '';
            _this.showIsEmpty = true;
            _this.secondaryControlName = '';
            _this.secondaryKeyValueControl = '';
            _this.positionMenu = 'auto';
            _this.debounceTimeEventInput = 350;
            _this._options = [];
            _this.debounceTimeInput = 0;
            _this.inputDebounce = new i0.EventEmitter();
            _this.selected = new i0.EventEmitter();
            _this.selectedEmpty = new i0.EventEmitter();
            _this.writeValue = function (value) {
                if (_this.rootRef && _this.keyLabel.length > 0) {
                    if (typeof value === 'string') {
                        _this.handleSaveValue(value);
                    }
                    else {
                        _this.rootRef.nativeElement.value = ngUtils.getNode(value, _this.keyLabel);
                        _this.handleSaveValue(value, false);
                    }
                }
                else {
                    setTimeout(function () {
                        _this.writeValue(value);
                    }, 10);
                }
            };
            return _this;
        }
        Object.defineProperty(NgAutocompleteComponent.prototype, "options", {
            set: function (value) {
                var _this = this;
                this._options = value.reduce(function (prev, current) {
                    var result = { _label: ngUtils.getNode(current, _this.keyLabel) };
                    if (_this.keyValue) {
                        result._value = ngUtils.getNode(current, _this.keyValue);
                    }
                    else {
                        result._value = current;
                    }
                    result._root = current;
                    return prev.concat(result);
                }, []);
            },
            enumerable: false,
            configurable: true
        });
        NgAutocompleteComponent.prototype.ngOnInit = function () {
            this.superOnInit('autocomplete');
        };
        NgAutocompleteComponent.prototype.ngAfterViewInit = function () {
            var _a, _b;
            this.superAfterViewInit();
            var typeConfig = (_a = this.ngConfig.typesInput) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()];
            var configGlobal = this.ngConfig.global.autocomplete;
            var type = this.type.toUpperCase();
            if (ngMasks.MASKS.typesCustom.includes(type) && this.mask === undefined) {
                this.mask = ngMasks.MASKS[type];
            }
            if (!(typeof this.mask === 'string') && this.mask !== undefined) {
                if (configGlobal === null || configGlobal === void 0 ? void 0 : configGlobal.mask) {
                    this.mask = Object.assign({}, configGlobal === null || configGlobal === void 0 ? void 0 : configGlobal.mask, this.mask);
                }
                if (typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask) {
                    this.mask = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask, this.mask);
                }
                if (((_b = this.mask) === null || _b === void 0 ? void 0 : _b.validator) === undefined) {
                    this.mask = Object.assign({}, this.mask, {
                        validator: this.required,
                    });
                }
            }
            if (this.mask !== undefined) {
                this._maskRef = this.ngMaskService.createMask(this.rootRef.nativeElement, this.mask, this.renderer2);
                if (ngMasks.MASKS.typesCustom.includes(type)) {
                    this.type = 'text';
                }
            }
            this.rootRef.nativeElement.blur();
            this.control.markAsUntouched();
            this.changeDetectorRef.detectChanges();
        };
        NgAutocompleteComponent.prototype.handleSaveValue = function (value, unmask) {
            if (unmask === void 0) { unmask = true; }
            if (this._maskRef) {
                this.handleChange(unmask ? this._maskRef.unmaskedValue() : value);
            }
            else {
                this.handleChange(value);
            }
        };
        NgAutocompleteComponent.prototype.handleInputDebounce = function (value) {
            var _this = this;
            clearTimeout(this.debounceTimeInput);
            this.debounceTimeInput = setTimeout(function () {
                _this.handleSearch(value);
                _this.inputDebounce.emit(value);
            }, this.debounceTimeEventInput);
        };
        NgAutocompleteComponent.prototype.handleSearch = function (value) {
            return __awaiter(this, void 0, void 0, function () {
                var _e, data;
                return __generator(this, function (_f) {
                    switch (_f.label) {
                        case 0:
                            if (!(this.service && value.length > 0)) return [3 /*break*/, 2];
                            this.loading = true;
                            return [4 /*yield*/, ngUtils.handleTry(this.service[this.methodService](value))];
                        case 1:
                            _e = __read.apply(void 0, [_f.sent(), 1]), data = _e[0];
                            if (data) {
                                this.options = data;
                            }
                            this.loading = false;
                            _f.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        NgAutocompleteComponent.prototype.handleSelect = function (option) {
            var _a, _b, _c, _d;
            if (option.option) {
                if (typeof ((_a = option.option.value) === null || _a === void 0 ? void 0 : _a._default) === 'string') {
                    this.handleEmpty(option.option.value._default);
                }
                else {
                    var optionRoot = (_b = compareOptions(this._options, this.keyValue, option.option.value)) === null || _b === void 0 ? void 0 : _b._root;
                    this.rootRef.nativeElement.value = ngUtils.getNode(optionRoot, this.keyLabel);
                    if (this.secondaryControlName) {
                        var value = ngUtils.getNode(optionRoot, this.secondaryKeyValueControl.split('.'));
                        (_c = this.control.root.get(this.secondaryControlName)) === null || _c === void 0 ? void 0 : _c.setValue(value);
                    }
                    this.selected.emit(option.option.value);
                }
            }
            else {
                this.rootRef.nativeElement.value = option._label;
                this.handleSaveValue(option._value);
                if (this.secondaryControlName) {
                    (_d = this.control.root
                        .get(this.secondaryControlName)) === null || _d === void 0 ? void 0 : _d.setValue(ngUtils.getNode(option._root, this.secondaryKeyValueControl));
                }
                this.selected.emit(option._value);
            }
        };
        NgAutocompleteComponent.prototype.handleEmpty = function (valueElement) {
            if (valueElement === void 0) { valueElement = this.rootRef.nativeElement.value; }
            this.rootRef.nativeElement.value = valueElement;
            this.handleSaveValue(valueElement);
            this.selectedEmpty.emit(valueElement);
        };
        NgAutocompleteComponent.prototype.handleBlur = function (event, index) {
            _super.prototype.handleBlur.call(this, event);
        };
        NgAutocompleteComponent.prototype.handleFocus = function (event) {
            _super.prototype.handleFocus.call(this, event);
        };
        NgAutocompleteComponent.prototype.handleInput = function (event) {
            var _a;
            if ((event === null || event === void 0 ? void 0 : event.key) !== 'Enter' && !((_a = event.key) === null || _a === void 0 ? void 0 : _a.match('Arrow'))) {
                var value = event.target.value;
                this.handleInputDebounce(value);
            }
        };
        return NgAutocompleteComponent;
    }(ControlBase));
    NgAutocompleteComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-autocomplete',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">\n  {{ label }}\n  <span class=\"ng-bt-required-symbol\" *ngIf=\"required\">*</span>\n</label>\n\n<div class=\"input-group\" cdkOverlayOrigin #trigger=\"cdkOverlayOrigin\">\n  <ng-icon\n    *ngIf=\"!loading\"\n    [icon]=\"icon?.left\"\n    className=\"ng-bt-icon__left\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, rootRef, 'left')\"\n  ></ng-icon>\n\n  <ng-icon\n    *ngIf=\"loading\"\n    [icon]=\"icon?.loading\"\n    className=\"ng-bt-icon__left\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, rootRef, 'left')\"\n  ></ng-icon>\n\n  <input\n    [id]=\"id\"\n    #rootRef\n    [type]=\"type\"\n    autocomplete=\"off\"\n    [readonly]=\"readonly\"\n    [required]=\"required\"\n    [formControl]=\"control\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    (blur)=\"handleBlur($event)\"\n    (focus)=\"handleFocus($event)\"\n    class=\"form-control shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-control-sm]=\"size === 'sm'\"\n    [class.form-control-lg]=\"size === 'lg'\"\n    [class.ng-bt-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-bt-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  />\n\n  <ng-select-dropdown\n    [trigger]=\"trigger\"\n    [options]=\"_options\"\n    (select)=\"handleSelect($event)\"\n    (selectEmpty)=\"handleEmpty($event)\"\n  >\n    <ng-content *ngIf=\"_options.length === 0 && showIsEmpty\"></ng-content>\n  </ng-select-dropdown>\n\n  <ng-icon\n    [icon]=\"icon?.right\"\n    className=\"ng-bt-icon__right\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, rootRef, 'right')\"\n  ></ng-icon>\n</div>\n\n<div class=\"ng-bt-helper\">\n  <span\n    class=\"ng-bt-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let key of _errorsKeys\">\n    <span\n      class=\"ng-bt-helper__text ng-bt-helper__error\"\n      *ngIf=\"control.touched && control.hasError(key)\"\n    >\n      {{ _errors[key] }}\n    </span>\n  </ng-container>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$5]
                },] }
    ];
    NgAutocompleteComponent.ctorParameters = function () { return [
        { type: i0.Renderer2 },
        { type: ngMasks.NgMaskService },
        { type: NgConfigService },
        { type: forms.ControlContainer },
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] }
    ]; };
    NgAutocompleteComponent.propDecorators = {
        loading: [{ type: i0.Input }],
        keyLabel: [{ type: i0.Input }],
        keyValue: [{ type: i0.Input }],
        showIsEmpty: [{ type: i0.Input }],
        secondaryControlName: [{ type: i0.Input }],
        secondaryKeyValueControl: [{ type: i0.Input }],
        positionMenu: [{ type: i0.Input }],
        service: [{ type: i0.Input }],
        methodService: [{ type: i0.Input }],
        debounceTimeEventInput: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        mask: [{ type: i0.Input }],
        inputDebounce: [{ type: i0.Output }],
        selected: [{ type: i0.Output }],
        selectedEmpty: [{ type: i0.Output }],
        handleInput: [{ type: i0.HostListener, args: ['keyup', ['$event'],] }]
    };

    var NgIconComponent = /** @class */ (function () {
        function NgIconComponent() {
            this.type = 'button';
            this.iconClick = new i0.EventEmitter();
        }
        Object.defineProperty(NgIconComponent.prototype, "icon", {
            set: function (icon) {
                if (icon) {
                    this._icon = Object.assign({}, icon);
                }
            },
            enumerable: false,
            configurable: true
        });
        NgIconComponent.prototype.ngOnInit = function () { };
        NgIconComponent.prototype.handleClick = function (event) {
            this.iconClick.emit({ event: event, icon: this._icon });
        };
        return NgIconComponent;
    }());
    NgIconComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-icon',
                    template: "<button\n  [type]=\"type\"\n  [disabled]=\"_icon?.disabled\"\n  *ngIf=\"_icon && !_icon?.hidden\"\n  (click)=\"handleClick($event)\"\n  [tabIndex]=\"_icon?.disabled || !_icon?.click ? -1 : 1\"\n  [class.shadow-focus]=\"!_icon?.disabled && _icon?.click\"\n  [class.ng-bt-icon__clickable]=\"!_icon?.disabled && _icon?.click\"\n  [class]=\"'ng-bt-icon input-group-text ' + _icon?.className + ' ' + className\"\n>\n  <i [class]=\"_icon?.icon\" [ngStyle]=\"{ color: _icon?.color }\"></i>\n</button>\n"
                },] }
    ];
    NgIconComponent.ctorParameters = function () { return []; };
    NgIconComponent.propDecorators = {
        icon: [{ type: i0.Input }],
        className: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        iconClick: [{ type: i0.Output }]
    };

    var NgIconModule = /** @class */ (function () {
        function NgIconModule() {
        }
        return NgIconModule;
    }());
    NgIconModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [NgIconComponent],
                    exports: [NgIconComponent],
                },] }
    ];

    var BaseModule = /** @class */ (function () {
        function BaseModule() {
        }
        return BaseModule;
    }());
    BaseModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [ControlBase],
                    exports: [ControlBase],
                },] }
    ];

    var NgSelectDropdownComponent = /** @class */ (function () {
        function NgSelectDropdownComponent(overlay) {
            var _this = this;
            this.overlay = overlay;
            this.selectEmpty = new i0.EventEmitter();
            this.select = new i0.EventEmitter();
            this._indexSelect = null;
            this._isOpen = false;
            this.keyMaps = {
                Enter: function () { return _this.handleSelect(); },
                ArrowDown: function () { return _this.handleArrowDown(); },
                ArrowUp: function () { return _this.handleArrowUp(); },
            };
            this.debouceBlur = 0;
        }
        Object.defineProperty(NgSelectDropdownComponent.prototype, "options", {
            set: function (options) {
                this._indexSelect = null;
                this._options = options;
            },
            enumerable: false,
            configurable: true
        });
        NgSelectDropdownComponent.prototype.ngOnInit = function () {
            var _this = this;
            var element = this.trigger.elementRef.nativeElement;
            element
                .querySelector('input')
                .addEventListener('focus', function () { return _this.handleOpen(); });
            element
                .querySelector('input')
                .addEventListener('click', function () { return _this.handleOpen(); });
            element.querySelector('input').addEventListener('keydown', function (event) {
                if (event.key === 'ArrowDown' || event.key === 'ArrowUp') {
                    _this.handleOpen();
                }
                if (event.key === 'Tab' || (event.key === 'Tab' && event.shiftKey)) {
                    _this.handleClose();
                }
            });
        };
        NgSelectDropdownComponent.prototype.handleResize = function () {
            this.overlayUpdate();
        };
        NgSelectDropdownComponent.prototype.handleKey = function (event) {
            if (ngUtils.contains(event.key, 'Arrow')) {
                if (this._indexSelect === null) {
                    this._indexSelect = 0;
                    return;
                }
            }
            var eventKey = this.keyMaps[event.key];
            if (eventKey) {
                eventKey();
            }
        };
        NgSelectDropdownComponent.prototype.handleArrowUp = function () {
            if (this._options.length > 0) {
                if (this._indexSelect === 0) {
                    this._indexSelect = this._options.length - 1;
                    this.handleScrollInto('end');
                }
                else {
                    this._indexSelect--;
                    this.handleScrollInto('start');
                }
            }
        };
        NgSelectDropdownComponent.prototype.handleArrowDown = function () {
            if (this._options.length > 0) {
                if (this._indexSelect === this._options.length - 1) {
                    this._indexSelect = 0;
                    this.handleScrollInto('start');
                }
                else {
                    this._indexSelect++;
                    this.handleScrollInto('end');
                }
            }
        };
        NgSelectDropdownComponent.prototype.handleSelect = function (index) {
            if (index === void 0) { index = this._indexSelect; }
            if (this._options.length === 0) {
                this.selectEmpty.emit();
            }
            else {
                this.select.emit(this._options[index]);
            }
            this.handleClose();
        };
        NgSelectDropdownComponent.prototype.handleScrollInto = function (block) {
            if (block === void 0) { block = 'nearest'; }
            var button = this.listRef.nativeElement.querySelector("button:nth-child(" + (this._indexSelect + 1) + ")");
            setTimeout(function () {
                button.scrollIntoView({ block: block, behavior: 'smooth' });
            });
        };
        NgSelectDropdownComponent.prototype.handleOpen = function () {
            this.overlayUpdate();
            this._isOpen = true;
        };
        NgSelectDropdownComponent.prototype.handleClose = function () {
            this.overlayUpdate();
            this._isOpen = false;
        };
        NgSelectDropdownComponent.prototype.overlayUpdate = function (event) {
            this._triggerRect =
                this.trigger.elementRef.nativeElement.getBoundingClientRect();
        };
        return NgSelectDropdownComponent;
    }());
    NgSelectDropdownComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-select-dropdown',
                    template: "<ng-template\n  cdkConnectedOverlay=\"overlayRef\"\n  (overlayKeydown)=\"handleKey($event)\"\n  [cdkConnectedOverlayOpen]=\"_isOpen\"\n  (overlayOutsideClick)=\"handleClose()\"\n  [cdkConnectedOverlayOrigin]=\"trigger\"\n  [cdkConnectedOverlayMinWidth]=\"_triggerRect?.width!\"\n>\n  <ul class=\"dropdown-menu ng-bt-dropdown show\" #listRef>\n    <button\n      (click)=\"handleSelect(0)\"\n      *ngIf=\"_options.length === 0\"\n      [class.active]=\"_indexSelect === 0\"\n      class=\"ng-bt-dropdown-item dropdown-item\"\n    >\n      <ng-content></ng-content>\n    </button>\n    <button\n      tabIndex=\"1\"\n      (click)=\"handleSelect(index)\"\n      (mouseenter)=\"_indexSelect = index\"\n      [class.active]=\"_indexSelect === index\"\n      class=\"ng-bt-dropdown-item dropdown-item\"\n      *ngFor=\"let option of _options; let index = index\"\n    >\n      {{ option._label }}\n    </button>\n  </ul>\n</ng-template>\n"
                },] }
    ];
    NgSelectDropdownComponent.ctorParameters = function () { return [
        { type: overlay.Overlay }
    ]; };
    NgSelectDropdownComponent.propDecorators = {
        listRef: [{ type: i0.ViewChild, args: ['listRef',] }],
        selectEmpty: [{ type: i0.Output }],
        select: [{ type: i0.Output }],
        trigger: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        handleResize: [{ type: i0.HostListener, args: ['window:resize', ['$event'],] }]
    };

    var NgAutocompleteModule = /** @class */ (function () {
        function NgAutocompleteModule() {
        }
        return NgAutocompleteModule;
    }());
    NgAutocompleteModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.ReactiveFormsModule,
                        BaseModule,
                        NgIconModule,
                        overlay.OverlayModule,
                    ],
                    declarations: [NgAutocompleteComponent, NgSelectDropdownComponent],
                    providers: [ngMasks.NgMaskService],
                    exports: [NgAutocompleteComponent, NgSelectDropdownComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$4 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgInputComponent; }),
        multi: true,
    };
    var NgInputComponent = /** @class */ (function (_super) {
        __extends(NgInputComponent, _super);
        function NgInputComponent(renderer2, ngMaskCurrencyService, ngMaskPercentService, ngMaskAmountService, ngFormatDateByTypeService, ngMaskService, ngConfig, changeDetectorRef, controlContainer) {
            var _this = _super.call(this, controlContainer, renderer2, ngConfig) || this;
            _this.renderer2 = renderer2;
            _this.ngMaskCurrencyService = ngMaskCurrencyService;
            _this.ngMaskPercentService = ngMaskPercentService;
            _this.ngMaskAmountService = ngMaskAmountService;
            _this.ngFormatDateByTypeService = ngFormatDateByTypeService;
            _this.ngMaskService = ngMaskService;
            _this.ngConfig = ngConfig;
            _this.changeDetectorRef = changeDetectorRef;
            _this.date = new Date();
            _this.autoFillDate = false;
            _this.writeValue = function (value) {
                if (_this.rootRef) {
                    if (_this._maskRef) {
                        _this._maskRef.update(value === null || value === void 0 ? void 0 : value.toString());
                    }
                    else {
                        if (_this.ngFormatDateByTypeService.typeDate.includes(_this.type)) {
                            if (!!value) {
                                _this.rootRef.nativeElement.value = _this.formatDate(value);
                            }
                        }
                        else {
                            _this.rootRef.nativeElement.value = value === null || value === void 0 ? void 0 : value.toString();
                        }
                    }
                    _this.handleInput(value, true);
                }
                else {
                    setTimeout(function () {
                        _this.writeValue(value);
                    }, 10);
                }
            };
            return _this;
        }
        NgInputComponent.prototype.ngOnInit = function () {
            this.superOnInit('input');
        };
        NgInputComponent.prototype.ngAfterViewInit = function () {
            var _a, _b, _c, _d, _e;
            this.superAfterViewInit();
            var typeConfig = (_a = this.ngConfig.typesInput) === null || _a === void 0 ? void 0 : _a[this.type.toLowerCase()];
            var configGlobal = this.ngConfig.global.input;
            if (this.type === 'currency') {
                this.currency = Object.assign({}, configGlobal === null || configGlobal === void 0 ? void 0 : configGlobal.currency, this.currency);
                if (((_b = this.currency) === null || _b === void 0 ? void 0 : _b.validator) === undefined) {
                    this.currency = Object.assign({}, this.currency, {
                        validator: this.required,
                    });
                }
                this.currency = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.currency, this.currency);
                this._maskRef = this.ngMaskCurrencyService.createMask(this.rootRef.nativeElement, this.currency, this.renderer2);
                this.type = 'text';
            }
            else if (this.type === 'percent') {
                this.percent = Object.assign({}, configGlobal === null || configGlobal === void 0 ? void 0 : configGlobal.percent, this.percent);
                if (((_c = this.percent) === null || _c === void 0 ? void 0 : _c.validator) === undefined) {
                    this.percent = Object.assign({}, this.percent, {
                        validator: this.required,
                    });
                }
                this.percent = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.percent, this.percent);
                this._maskRef = this.ngMaskPercentService.createMask(this.rootRef.nativeElement, this.percent, this.renderer2);
                this.type = 'text';
            }
            else if (this.type === 'amount') {
                this.amount = Object.assign({}, configGlobal === null || configGlobal === void 0 ? void 0 : configGlobal.amount, this.amount);
                if (((_d = this.amount) === null || _d === void 0 ? void 0 : _d.validator) === undefined) {
                    this.amount = Object.assign({}, this.amount, {
                        validator: this.required,
                    });
                }
                this.amount = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.amount, this.amount);
                this._maskRef = this.ngMaskAmountService.createMask(this.rootRef.nativeElement, this.amount, this.renderer2);
                this.type = 'text';
            }
            else {
                var type = this.type.toUpperCase();
                if (ngMasks.MASKS.typesCustom.includes(type) && this.mask === undefined) {
                    this.mask = ngMasks.MASKS[type];
                }
                if (!(typeof this.mask === 'string') && this.mask !== undefined) {
                    if (configGlobal === null || configGlobal === void 0 ? void 0 : configGlobal.mask) {
                        this.mask = Object.assign({}, configGlobal === null || configGlobal === void 0 ? void 0 : configGlobal.mask, this.mask);
                    }
                    if (typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask) {
                        this.mask = Object.assign({}, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.mask, this.mask);
                    }
                    if (((_e = this.mask) === null || _e === void 0 ? void 0 : _e.validator) === undefined) {
                        this.mask = Object.assign({}, this.mask, {
                            validator: this.required,
                        });
                    }
                }
                if (this.mask !== undefined) {
                    this._maskRef = this.ngMaskService.createMask(this.rootRef.nativeElement, this.mask, this.renderer2);
                    if (ngMasks.MASKS.typesCustom.includes(type)) {
                        this.type = 'text';
                    }
                }
            }
            if (this.autoFillDate &&
                this.ngFormatDateByTypeService.typeDate.includes(this.type)) {
                this.rootRef.nativeElement.value = this.formatDate(this.date);
            }
            this.rootRef.nativeElement.blur();
            this.control.markAsUntouched();
            this.changeDetectorRef.detectChanges();
        };
        NgInputComponent.prototype.formatDate = function (value) {
            return this.ngFormatDateByTypeService.format(value.toString(), this.type);
        };
        NgInputComponent.prototype.handleInput = function (value, delay) {
            var _this = this;
            if (delay === void 0) { delay = false; }
            if (this._maskRef) {
                if (delay) {
                    setTimeout(function () {
                        _this.handleChange(_this._maskRef.unmaskedValue());
                    });
                }
                else {
                    this.handleChange(this._maskRef.unmaskedValue());
                }
            }
            else {
                this.handleChange(value);
            }
        };
        return NgInputComponent;
    }(ControlBase));
    NgInputComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-input',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">\n  {{ label }}\n  <span class=\"ng-bt-required-symbol\" *ngIf=\"required\">*</span>\n</label>\n\n<div class=\"input-group\">\n  <ng-icon\n    [icon]=\"icon?.left\"\n    className=\"ng-bt-icon__left\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, rootRef, 'left')\"\n  ></ng-icon>\n\n  <input\n    [id]=\"id\"\n    #rootRef\n    [type]=\"type\"\n    [required]=\"required\"\n    [readonly]=\"readonly\"\n    [formControl]=\"control\"\n    [attr.maxlength]=\"length\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    (blur)=\"handleBlur($event)\"\n    (focus)=\"handleFocus($event)\"\n    class=\"form-control shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-control-sm]=\"size === 'sm'\"\n    [class.form-control-lg]=\"size === 'lg'\"\n    [class.ng-bt-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-bt-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  />\n\n  <ng-icon\n    [icon]=\"icon?.right\"\n    className=\"ng-bt-icon__right\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, rootRef, 'right')\"\n  ></ng-icon>\n</div>\n\n<div class=\"ng-bt-helper\">\n  <span\n    class=\"ng-bt-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let key of _errorsKeys\">\n    <span\n      class=\"ng-bt-helper__text ng-bt-helper__error\"\n      *ngIf=\"control.touched && control.hasError(key)\"\n    >\n      {{ _errors[key] }}\n    </span>\n  </ng-container>\n\n  <span class=\"ng-bt-helper__counter text-muted\" *ngIf=\"length\">\n    {{ rootRef?.value?.length }}/{{ length }}\n  </span>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$4]
                },] }
    ];
    NgInputComponent.ctorParameters = function () { return [
        { type: i0.Renderer2 },
        { type: ngMasks.NgMaskCurrencyService },
        { type: ngMasks.NgMaskPercentService },
        { type: ngMasks.NgMaskAmountService },
        { type: NgFormatDateByTypeService },
        { type: ngMasks.NgMaskService },
        { type: NgConfigService },
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] },
        { type: forms.ControlContainer }
    ]; };
    NgInputComponent.propDecorators = {
        amount: [{ type: i0.Input }],
        percent: [{ type: i0.Input }],
        currency: [{ type: i0.Input }],
        length: [{ type: i0.Input }],
        mask: [{ type: i0.Input }],
        date: [{ type: i0.Input }],
        autoFillDate: [{ type: i0.Input }],
        handleInput: [{ type: i0.HostListener, args: ['input', ['$event.target.value'],] }]
    };

    var NgInputModule = /** @class */ (function () {
        function NgInputModule() {
        }
        return NgInputModule;
    }());
    NgInputModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        NgConfigModule,
                        ngMasks.NgMasksServicesModule,
                        forms.ReactiveFormsModule,
                        NgUtilsServiceModule,
                        NgIconModule,
                        BaseModule,
                    ],
                    declarations: [NgInputComponent],
                    exports: [NgInputComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$3 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgSelectComponent; }),
        multi: true,
    };
    var NgSelectComponent = /** @class */ (function (_super) {
        __extends(NgSelectComponent, _super);
        function NgSelectComponent(controlContainer, renderer2, ngInputConfig, elementRef, changeDetectorRef) {
            var _this = _super.call(this, renderer2, elementRef) || this;
            _this.controlContainer = controlContainer;
            _this.renderer2 = renderer2;
            _this.ngInputConfig = ngInputConfig;
            _this.label = '';
            _this.type = 'select';
            _this.readonly = false;
            _this.multiple = false;
            _this.disabled = false;
            _this.labelFixed = false;
            _this.theme = 'outline';
            _this.color = 'primary';
            _this.required = null;
            _this.keyValue = '';
            _this.keyCompare = '';
            _this.firstOptionValue = '';
            _this.size = 'md';
            _this.position = 'start';
            _this._options = [];
            _this.handleCompareWithBind = _this.handleCompareWith.bind(_this);
            _this.focus = new i0.EventEmitter();
            _this.selected = new i0.EventEmitter();
            _this.handleChange = function (_) { };
            _this.setDisabledState = function (isDisabled) { return (_this.disabled = isDisabled); };
            _this.registerOnChange = function (fn) { return (_this.handleChange = fn); };
            _this.writeValue = function (value) { };
            return _this;
        }
        Object.defineProperty(NgSelectComponent.prototype, "options", {
            set: function (options) {
                var _this = this;
                this._options = options.map(function (option) {
                    var label = '';
                    var value = '';
                    if (!(option === null || option === void 0 ? void 0 : option._label)) {
                        label = ngUtils.getNode(option, _this.keyLabel);
                    }
                    if (!(typeof option._value === 'string')) {
                        if (_this.keyValue) {
                            value = ngUtils.getNode(option, _this.keyValue);
                        }
                        else {
                            value = option._value || option;
                        }
                    }
                    option = {
                        _label: label,
                        _value: value,
                        _root: option,
                    };
                    return option;
                });
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSelectComponent.prototype, "placeholder", {
            set: function (text) {
                var _a;
                this._placeholder = text;
                if (!!text && ((_a = this.rootRef) === null || _a === void 0 ? void 0 : _a.nativeElement)) {
                    this.renderer2.setAttribute(this.rootRef.nativeElement, 'placeholder', text);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSelectComponent.prototype, "errors", {
            set: function (errors) {
                if (errors) {
                    this._errors = errors;
                    this._errorsKeys = Object.keys(errors);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgSelectComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl ||
                    ((_b = (_a = this.controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgSelectComponent.prototype.ngOnInit = function () {
            var _a, _b;
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
            if (this.required === null) {
                var value = this.control.value;
                this.control.reset();
                this.required = !!this.control.getError('required');
                this.control.setValue(value);
            }
            var typeConfig = (_a = this.ngInputConfig.typesSelect) === null || _a === void 0 ? void 0 : _a[this.type];
            this.icon = Object.assign({}, (_b = this.ngInputConfig.select) === null || _b === void 0 ? void 0 : _b.icon, typeConfig === null || typeConfig === void 0 ? void 0 : typeConfig.icon, this.icon);
        };
        NgSelectComponent.prototype.ngAfterViewInit = function () {
            if (!!this._placeholder) {
                this.placeholder = this._placeholder;
            }
        };
        NgSelectComponent.prototype.handleCompareWith = function (itemOne, itemTwo) {
            if (!!this.keyValue) {
                itemOne = compareOptions(this._options, this.keyValue, itemOne)._root;
            }
            if (!!this.keyValue) {
                itemTwo = compareOptions(this._options, this.keyValue, itemTwo)._root;
            }
            return itemOne && itemTwo
                ? compareObject(ngUtils.getNode(itemOne, this.keyCompare), ngUtils.getNode(itemTwo, this.keyCompare))
                : itemOne === itemTwo;
        };
        NgSelectComponent.prototype.handleClickIcon = function (prop, input, position) {
            var _a;
            prop.event.stopPropagation();
            if ((_a = prop.icon) === null || _a === void 0 ? void 0 : _a.click) {
                prop.icon.click(prop.event, input, prop.icon, position);
            }
            else {
                input.focus();
            }
        };
        NgSelectComponent.prototype.handleBlur = function (event) {
            throw new Error('Method not implemented.');
        };
        NgSelectComponent.prototype.handleFocus = function (event) {
            this.focus.emit(event);
        };
        NgSelectComponent.prototype.handleSelect = function (option) {
            this.selected.emit(option.value);
        };
        NgSelectComponent.prototype.handleInput = function (value) {
            this.handleChange(value);
        };
        return NgSelectComponent;
    }(forms.SelectControlValueAccessor));
    NgSelectComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-select',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">\n  {{ label }}\n  <span class=\"ng-bt-required-symbol\" *ngIf=\"required\">*</span>\n</label>\n\n<div class=\"input-group\">\n  <ng-icon\n    [icon]=\"icon?.left\"\n    className=\"ng-bt-icon__left\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, selectRef, 'left')\"\n  ></ng-icon>\n\n  <select\n    [id]=\"id\"\n    #selectRef\n    [required]=\"required\"\n    [formControl]=\"control\"\n    [attr.readonly]=\"readonly\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    (focus)=\"handleFocus($event)\"\n    class=\"form-select shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-select-sm]=\"size === 'sm'\"\n    [class.form-select-lg]=\"size === 'lg'\"\n    [compareWith]=\"handleCompareWith.bind(this)\"\n    [class.ng-bt-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-bt-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  >\n    <ng-container *ngIf=\"position === 'start'\">\n      <option *ngFor=\"let option of _options\" [ngValue]=\"option._value\">\n        {{ option._label }}\n      </option>\n    </ng-container>\n\n    <ng-content></ng-content>\n\n    <ng-container *ngIf=\"position === 'end'\">\n      <option *ngFor=\"let option of _options\" [ngValue]=\"option._value\">\n        {{ option._label }}\n      </option>\n    </ng-container>\n  </select>\n\n  <ng-icon\n    [icon]=\"icon?.right\"\n    className=\"ng-bt-icon__right\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, selectRef, 'right')\"\n  ></ng-icon>\n</div>\n\n<div class=\"ng-bt-helper\">\n  <span\n    class=\"ng-bt-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let key of _errorsKeys\">\n    <span\n      class=\"ng-bt-helper__text ng-bt-helper__error\"\n      *ngIf=\"control.touched && control.hasError(key)\"\n    >\n      {{ _errors[key] }}\n    </span>\n  </ng-container>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$3]
                },] }
    ];
    NgSelectComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: NgConfigService },
        { type: i0.ElementRef },
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] }
    ]; };
    NgSelectComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        rootRef: [{ type: i0.ViewChild, args: ['rootRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        prefix: [{ type: i0.Input }],
        suffix: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        multiple: [{ type: i0.Input }],
        labelFixed: [{ type: i0.Input }],
        theme: [{ type: i0.Input }],
        help: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        icon: [{ type: i0.Input }],
        keyLabel: [{ type: i0.Input }],
        keyValue: [{ type: i0.Input }],
        keyCompare: [{ type: i0.Input }],
        firstOptionLabel: [{ type: i0.Input }],
        firstOptionValue: [{ type: i0.Input }],
        size: [{ type: i0.Input }],
        position: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        placeholder: [{ type: i0.Input }],
        errors: [{ type: i0.Input }],
        focus: [{ type: i0.Output }],
        selected: [{ type: i0.Output }]
    };

    var NgSelectModule = /** @class */ (function () {
        function NgSelectModule() {
        }
        return NgSelectModule;
    }());
    NgSelectModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, NgConfigModule, NgIconModule, forms.ReactiveFormsModule],
                    declarations: [NgSelectComponent],
                    exports: [NgSelectComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$2 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgTextAreaComponent; }),
        multi: true,
    };
    var NgTextAreaComponent = /** @class */ (function (_super) {
        __extends(NgTextAreaComponent, _super);
        function NgTextAreaComponent(changeDetectorRef, ngConfig, renderer2, controlContainer) {
            var _this = _super.call(this, controlContainer, renderer2, ngConfig) || this;
            _this.changeDetectorRef = changeDetectorRef;
            _this.rows = 3;
            _this.cols = 3;
            return _this;
        }
        NgTextAreaComponent.prototype.ngOnInit = function () {
            this.superOnInit('textArea');
        };
        NgTextAreaComponent.prototype.ngAfterViewInit = function () {
            var _a;
            this.superAfterViewInit();
            this.rootRef.nativeElement.blur();
            (_a = this.control) === null || _a === void 0 ? void 0 : _a.markAsUntouched();
            this.changeDetectorRef.detectChanges();
        };
        return NgTextAreaComponent;
    }(ControlBase));
    NgTextAreaComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-text-area',
                    template: "<label class=\"form-label\" *ngIf=\"label\" [for]=\"id\">\n  {{ label }}\n  <span class=\"ng-bt-required-symbol\" *ngIf=\"required\">*</span>\n</label>\n\n<div class=\"input-group\">\n  <ng-icon\n    [icon]=\"icon?.left\"\n    className=\"ng-icon__left\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, rootRef, 'left')\"\n  ></ng-icon>\n\n  <textarea\n    [id]=\"id\"\n    #rootRef\n    [rows]=\"rows\"\n    [cols]=\"cols\"\n    [required]=\"required\"\n    [readonly]=\"readonly\"\n    [formControl]=\"control\"\n    [attr.maxlength]=\"length\"\n    [class.disabled]=\"disabled\"\n    [class.readonly]=\"readonly\"\n    (blur)=\"handleBlur($event)\"\n    (focus)=\"handleFocus($event)\"\n    class=\"form-control shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n    [class.form-control-sm]=\"size === 'sm'\"\n    [class.form-control-lg]=\"size === 'lg'\"\n    [class.ng-icon__left]=\"icon?.left && !icon?.left?.hidden\"\n    [class.ng-icon__right]=\"icon?.right && !icon?.right?.hidden\"\n    [class.is-valid]=\"this.control.touched && this.control.valid\"\n    [class.is-invalid]=\"this.control.touched && this.control.invalid\"\n  >\n  <ng-content></ng-content>\n  </textarea>\n\n  <ng-icon\n    [icon]=\"icon?.right\"\n    className=\"ng-bt-icon__right\"\n    [class.is-valid]=\"control.valid && control.touched\"\n    [class.is-invalid]=\"control.invalid && control.touched\"\n    (iconClick)=\"handleClickIcon($event, rootRef, 'right')\"\n  ></ng-icon>\n</div>\n\n<div class=\"ng-bt-helper\">\n  <span\n    class=\"ng-bt-helper__text text-muted\"\n    *ngIf=\"help && !(control.touched && control.invalid)\"\n  >\n    {{ help }}\n  </span>\n\n  <ng-container *ngFor=\"let key of _errorsKeys\">\n    <span\n      class=\"ng-bt-helper__text ng-bt-helper__error\"\n      *ngIf=\"control.touched && control.hasError(key)\"\n    >\n      {{ _errors[key] }}\n    </span>\n  </ng-container>\n\n  <span class=\"ng-bt-helper__counter text-muted\" *ngIf=\"length\">\n    {{ rootRef?.value?.length }}/{{ length }}\n  </span>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$2]
                },] }
    ];
    NgTextAreaComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef, decorators: [{ type: i0.SkipSelf }] },
        { type: NgConfigService },
        { type: i0.Renderer2 },
        { type: forms.ControlContainer }
    ]; };
    NgTextAreaComponent.propDecorators = {
        rows: [{ type: i0.Input }],
        cols: [{ type: i0.Input }],
        length: [{ type: i0.Input }]
    };

    var NgTextAreaModule = /** @class */ (function () {
        function NgTextAreaModule() {
        }
        return NgTextAreaModule;
    }());
    NgTextAreaModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, BaseModule, forms.ReactiveFormsModule, NgIconModule],
                    declarations: [NgTextAreaComponent],
                    exports: [NgTextAreaComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR$1 = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgCheckboxComponent; }),
        multi: true,
    };
    var NgCheckboxComponent = /** @class */ (function (_super) {
        __extends(NgCheckboxComponent, _super);
        function NgCheckboxComponent(controlContainer, renderer2, elementRef) {
            var _this = _super.call(this, renderer2, elementRef) || this;
            _this.controlContainer = controlContainer;
            _this.renderer2 = renderer2;
            _this.elementRef = elementRef;
            _this.indeterminate = false;
            _this.type = 'checkbox';
            _this.color = 'primary';
            _this.required = false;
            _this.labelPosition = 'after';
            return _this;
        }
        Object.defineProperty(NgCheckboxComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl ||
                    ((_b = (_a = this.controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgCheckboxComponent.prototype.ngOnInit = function () {
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
        };
        NgCheckboxComponent.prototype.ngAfterViewInit = function () { };
        return NgCheckboxComponent;
    }(forms.CheckboxControlValueAccessor));
    NgCheckboxComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-checkbox',
                    template: "<div class=\"form-check form-check-inline\">\n  <input\n    [id]=\"id\"\n    #checkboxRef\n    type=\"checkbox\"\n    [required]=\"required\"\n    [formControl]=\"control\"\n    class=\"form-check-input shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n  />\n  <label [for]=\"id\" class=\"form-check-label\">\n    <ng-content></ng-content>\n  </label>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR$1]
                },] }
    ];
    NgCheckboxComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: i0.ElementRef }
    ]; };
    NgCheckboxComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        checkboxRef: [{ type: i0.ViewChild, args: ['checkboxRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        indeterminate: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        labelPosition: [{ type: i0.Input }]
    };

    var NgCheckboxModule = /** @class */ (function () {
        function NgCheckboxModule() {
        }
        return NgCheckboxModule;
    }());
    NgCheckboxModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, forms.ReactiveFormsModule],
                    declarations: [NgCheckboxComponent],
                    exports: [NgCheckboxComponent],
                },] }
    ];

    var PROVIDER_VALUE_ACCESSOR = {
        provide: forms.NG_VALUE_ACCESSOR,
        useExisting: i0.forwardRef(function () { return NgSwitchComponent; }),
        multi: true,
    };
    var NgSwitchComponent = /** @class */ (function (_super) {
        __extends(NgSwitchComponent, _super);
        function NgSwitchComponent(controlContainer, renderer2, elementRef) {
            var _this = _super.call(this, renderer2, elementRef) || this;
            _this.controlContainer = controlContainer;
            _this.renderer2 = renderer2;
            _this.elementRef = elementRef;
            _this.type = 'checkbox';
            _this.color = 'primary';
            _this.required = false;
            _this.labelPosition = 'after';
            return _this;
        }
        Object.defineProperty(NgSwitchComponent.prototype, "control", {
            get: function () {
                var _a, _b;
                return (this.formControl ||
                    ((_b = (_a = this.controlContainer) === null || _a === void 0 ? void 0 : _a.control) === null || _b === void 0 ? void 0 : _b.get(this.formControlName)));
            },
            enumerable: false,
            configurable: true
        });
        NgSwitchComponent.prototype.ngOnInit = function () {
            if (this.id === undefined) {
                this.id = this.formControlName;
            }
        };
        return NgSwitchComponent;
    }(forms.CheckboxControlValueAccessor));
    NgSwitchComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ng-switch',
                    template: "<div class=\"form-check form-switch form-check-inline\">\n  <input\n    [id]=\"id\"\n    #checkboxRef\n    type=\"checkbox\"\n    [required]=\"required\"\n    [formControl]=\"control\"\n    class=\"form-check-input shadow-focus\"\n    [tabIndex]=\"control.disabled ? -1 : 1\"\n  />\n  <label [for]=\"id\" class=\"form-check-label\">\n    <ng-content></ng-content>\n  </label>\n</div>\n",
                    providers: [PROVIDER_VALUE_ACCESSOR]
                },] }
    ];
    NgSwitchComponent.ctorParameters = function () { return [
        { type: forms.ControlContainer },
        { type: i0.Renderer2 },
        { type: i0.ElementRef }
    ]; };
    NgSwitchComponent.propDecorators = {
        formControlDirective: [{ type: i0.ViewChild, args: [forms.FormControlDirective, { static: true },] }],
        checkboxRef: [{ type: i0.ViewChild, args: ['checkboxRef',] }],
        formControl: [{ type: i0.Input }],
        formControlName: [{ type: i0.Input }],
        id: [{ type: i0.Input }],
        readonly: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        labelPosition: [{ type: i0.Input }]
    };

    var NgSwitchModule = /** @class */ (function () {
        function NgSwitchModule() {
        }
        return NgSwitchModule;
    }());
    NgSwitchModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, forms.ReactiveFormsModule],
                    declarations: [NgSwitchComponent],
                    exports: [NgSwitchComponent],
                },] }
    ];

    /*
     * Public API Surface of ng-fields
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.FOR_ROOT_OPTIONS_TOKEN = FOR_ROOT_OPTIONS_TOKEN;
    exports.NgAutocompleteComponent = NgAutocompleteComponent;
    exports.NgAutocompleteModule = NgAutocompleteModule;
    exports.NgCheckboxComponent = NgCheckboxComponent;
    exports.NgCheckboxModule = NgCheckboxModule;
    exports.NgFormatDateByTypeService = NgFormatDateByTypeService;
    exports.NgInputComponent = NgInputComponent;
    exports.NgInputModule = NgInputModule;
    exports.NgInputsBootstrap = NgInputsBootstrap;
    exports.NgSelectComponent = NgSelectComponent;
    exports.NgSelectModule = NgSelectModule;
    exports.NgSwitchComponent = NgSwitchComponent;
    exports.NgSwitchModule = NgSwitchModule;
    exports.NgTextAreaComponent = NgTextAreaComponent;
    exports.NgTextAreaModule = NgTextAreaModule;
    exports.NgUtilsServiceModule = NgUtilsServiceModule;
    exports.provideMyServiceOptions = provideMyServiceOptions;
    exports.ɵa = NgConfigModule;
    exports.ɵb = NgConfigService;
    exports.ɵc = BaseModule;
    exports.ɵd = ControlBase;
    exports.ɵe = NgIconModule;
    exports.ɵf = NgIconComponent;
    exports.ɵg = NgSelectDropdownComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=douglas-serena-ng-inputs-bootstrap.umd.js.map
