import { AfterViewInit, ChangeDetectorRef, OnInit, Renderer2 } from '@angular/core';
import { ControlContainer, ControlValueAccessor } from '@angular/forms';
import { NgConfigService } from '../../config/ng-config.service';
import { NgFormatDateByTypeService } from '../../services/utils/ng-format-date-by-type.service';
import { ControlBase } from '../../shared/base/control-base.template';
import { IMaskServiceReturn, INgIMaskConfig, INgMaskConfig, NgMaskAmountService, NgMaskCurrencyService, NgMaskPercentService, NgMaskService } from '@douglas-serena/ng-masks';
export declare class NgInputComponent extends ControlBase implements OnInit, AfterViewInit, ControlValueAccessor {
    private renderer2;
    private ngMaskCurrencyService;
    private ngMaskPercentService;
    private ngMaskAmountService;
    private ngFormatDateByTypeService;
    private ngMaskService;
    private ngConfig;
    private changeDetectorRef;
    amount: INgMaskConfig;
    percent: INgMaskConfig;
    currency: INgMaskConfig;
    length: string | number;
    mask: INgIMaskConfig | string;
    date: Date | string;
    autoFillDate: boolean;
    _maskRef: IMaskServiceReturn;
    constructor(renderer2: Renderer2, ngMaskCurrencyService: NgMaskCurrencyService, ngMaskPercentService: NgMaskPercentService, ngMaskAmountService: NgMaskAmountService, ngFormatDateByTypeService: NgFormatDateByTypeService, ngMaskService: NgMaskService, ngConfig: NgConfigService, changeDetectorRef: ChangeDetectorRef, controlContainer: ControlContainer);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    formatDate(value: any): string;
    handleInput(value?: HTMLElement | string | number, delay?: boolean): void;
    writeValue: (value: number | string) => void;
}
