import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnInit, Renderer2 } from '@angular/core';
import { ControlContainer, FormControl, FormControlDirective, SelectControlValueAccessor } from '@angular/forms';
import { NgConfigService } from '../../config/ng-config.service';
import { INgIconConfig, NgIconPositionsConfig } from '../../interfaces/config/ng-icon-config.interface';
import { INgOption } from '../../interfaces/ng-option.interface';
import { NgControlBase } from '../../shared/base/control-base.interface';
export interface NgSelectOptions {
    position?: 'start' | 'end';
    keyLabel?: string | string[];
    keyValue?: string | string[];
    keyCompare?: string | string[];
    options: INgOption[];
}
export declare class NgSelectComponent extends SelectControlValueAccessor implements OnInit, NgControlBase, AfterViewInit {
    private controlContainer;
    private renderer2;
    private ngInputConfig;
    formControlDirective: FormControlDirective;
    rootRef: ElementRef<HTMLInputElement>;
    formControl: FormControl;
    formControlName: string;
    id: string;
    label: string;
    type: string;
    prefix: string;
    suffix: string;
    readonly: boolean;
    multiple: boolean;
    disabled: boolean;
    labelFixed: boolean;
    theme: 'outline' | 'fill' | 'standard' | 'legacy';
    help: string;
    color: string;
    required: boolean | null;
    icon: NgIconPositionsConfig;
    keyLabel: string;
    keyValue: string;
    keyCompare: string;
    firstOptionLabel: string;
    firstOptionValue: any;
    size: 'lg' | 'md' | 'sm';
    position: 'start' | 'end';
    set options(options: INgOption[]);
    _options: INgOption[];
    set placeholder(text: string | null);
    _placeholder?: string | null;
    set errors(errors: {
        [key: string]: string;
    } | null);
    _errors: {
        [key: string]: string;
    };
    _errorsKeys: string[];
    get control(): FormControl;
    constructor(controlContainer: ControlContainer, renderer2: Renderer2, ngInputConfig: NgConfigService, elementRef: ElementRef<any>, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    handleCompareWith(itemOne: any, itemTwo: any): boolean;
    handleCompareWithBind: (itemOne: any, itemTwo: any) => boolean;
    handleClickIcon(prop: {
        event: Event;
        icon: INgIconConfig | undefined;
    }, input: any, position: 'left' | 'right' | 'loading'): void;
    blur: EventEmitter<any>;
    handleBlur(event: FocusEvent): void;
    focus: EventEmitter<any>;
    handleFocus(event: any): void;
    selected: EventEmitter<any>;
    handleSelect(option: any): void;
    handleInput(value?: HTMLElement | string | number): void;
    handleChange: (_: any) => void;
    setDisabledState: (isDisabled: boolean) => boolean;
    registerOnChange: (fn: (_: any) => void) => (_: any) => void;
    writeValue: (value: number | string) => void;
}
